#https://stackoverflow.com/questions/7674790/bundling-data-files-with-pyinstaller-onefile/13790741#13790741
#possible way to incorperate all files into onefile for pyinstaller to exe file -- not key focus, for now,
#       export the exe using auto-py-to-exe and place the exe and audiofiles folder and db in one folder



import os                           #to find file paths
import time                         #to sleep the program for length of mp3 file
import random                       #random
import pygame                       #to play the mp3 files
import mutagen                      #get length of mp3 files to sleep program when playing
import datetime                     #to get date and time for crash log
from tkinter import *               #import main tkinter modules
from tkinter import messagebox      #to throw error popups when required
import tkinter.font as font         #to edit button text formatting
import sqlite3                      #for db using sqlite
import ctypes                       #used to increase sharpness of tkinter windows
import pyaudio                      #used for mic passthrough for manual announcements.
import tkinter as tk





##Screens##

def init_screen():
    global init      #to ensure that the init window can be used anywhere in the program
    
    close()         #close all other open windows
    init = Tk()     #create window
    init.state("zoomed")                        #sets the window to fullscreen
    init.resizable(False, False)                #disallows the user to resize the window
    init.title("Train Announcement Systems - Initialisation")    #sets the title of the window
    label_one(init)                             #displays the main title
    label_two(init,'Program Initialisation')    #displays the secondary title, which is defined here
    button_b(init,'Manual Entry\n\n(Will auto delete all \ncurrently stored data)',manualEntry_screen_setup,1,1)         #creates buttons as required, using 'b' or 's' subroutines
    button_b(init,'Recover Autosave',recAutosave,2,1)
    button_b(init,'Import Preset',presetOptions,3,1)
    button_d(init,'Quit Program',quitprogram,3,4)

    init.mainloop()         #loop whilst the window is open


def manualEntry_screen():
    global manualEntry,ManEntCounter,clicked     #to ensure that the manualEntry window can be used anywhere in the program
    
    close()             #close all other open window
    manualEntry = Tk()          #create window
    manualEntry.state("zoomed")                        #sets the window to fullscreen
    manualEntry.resizable(False, False)                #disallows the user to resize the window
    manualEntry.title("Train Announcement Systems - Manual Entry")    #sets the title of the window
    label_one(manualEntry)                             #displays the main title
    label_two(manualEntry,'Manual Entry - Stop {}'.format(ManEntCounter))    #displays the secondary title, which is defined here
    button_b(manualEntry,'Confirm and select \nnext stop',add_stop_to_RouteStops,1,2) #creates buttons as required, using 'b' or 's' subroutines
    button_s(manualEntry,'Finish Route Planning',main_valid,2,3)
    button_d(manualEntry,'Reset Route',manualEntry_screen_setup,2,4)
    button_s(manualEntry,'Initialisation Menu',init_screen,3,3)
    button_d(manualEntry,'Quit Program',quitprogram,3,4)

    data = read_db_col('AllAvailFiles','StopName')           #recovers all the options for stops available to the user

    options = []

    for i in range (len(data)):
        options.append(str(data[i]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))

    options = sorted(options)                                   #sorts the list into alphabetical order
    
    clicked = StringVar(manualEntry)
    clicked.set('Select Stop {}'.format(ManEntCounter))             #sets the text in the dropdown before option selected


    drop = OptionMenu(manualEntry,clicked,*options)   #creates the dropdown menu  
    drop.config(width=20, font=('Arial',20))        #Defines the text formatting for the dropdown
    drop.place(relx=0.5,rely=0.45,anchor='center')  #places the dropdown


    manualEntry.mainloop()          #loop whilst the window is open

    
    
    
def main_screen():          #window for the main buttons
    global main,prov_pin             #global to allow close() to run
    close()                 #close all other windows
    main = Tk()             #create window
    main.state("zoomed")    #set window to fullscreen
    main.resizable(False, False)                #disallows the user to resize the window
    main.title('Train Announcement Systems - Main Menu')        #set title of window
    label_one(main)                 #sets main title in the 'main' window
    label_two(main,'Main Menu')     #sets secondary title
    label_nxtstop(main)

    prov_pin = ''

    button_b(main,'Play Welcome',playWelcomeSETUP,1,1)         #creates all buttons in the correct place 
    button_b(main,'Play Next Stop',playNextStop,2,1)           #using the grid system in the button_b/s/d subroutines
    button_b(main,'Play Approaching',playApproaching,3,1)
    button_b(main,'Play This is',playThisIs,1,2)
    button_b(main,'Play BTP',playBTP,2,2)
    button_s(main,'Options',options_screen,3,3)
    button_d(main,'Quit Program',quitprogram,3,4)

    main.mainloop()         #loop whilst the window is open


def playWelcomeSETUP():
    global WelcSetup             #global to allow close() to run
    close()                 #close all other windows
    WelcSetup = Tk()             #create window
    WelcSetup.state("zoomed")    #set window to fullscreen
    WelcSetup.resizable(False, False)                #disallows the user to resize the window
    WelcSetup.title('Train Announcement Systems - Welcome Message Option')        #set title of window
    label_one(WelcSetup)                 #sets main title in the 'main' window
    label_two(WelcSetup,'Do you want to play the BTP message after the welcome message?\nAfter 3 times WITHOUT BTP, the program will ask you to confirm this.')     #sets secondary title
    label_nxtstop(WelcSetup)

    button_b(WelcSetup,'WITH BTP',playWelcomeYESBTP,0.3,0.58)         #creates all buttons in the correct place 
    button_b(WelcSetup,'WITHOUT BTP',playWelcomeNOBTP,0.7,0.58)           #using the grid system in the button_b/s/d subroutines


    WelcSetup.mainloop()    #loop whilst the window is open


def options_screen():
    global optionsMenu             #global to allow close() to run
    close()                 #close all other windows
    optionsMenu = Tk()             #create window
    optionsMenu.state("zoomed")    #set window to fullscreen
    optionsMenu.resizable(False, False)                #disallows the user to resize the window
    optionsMenu.title('Train Announcement Systems - Options Menu')        #set title of window
    label_one(optionsMenu)                 #sets main title in the 'main' window
    label_two(optionsMenu,'Options Menu')     #sets secondary title
    label_nxtstop(optionsMenu)

    button_b(optionsMenu,'Edit Stops',editStops_menu,1,1)         #creates all buttons in the correct place 
    button_b(optionsMenu,'Skip Stop',skipStop,2,1)           #using the grid system in the button_b/s/d subroutines
    button_dbig(optionsMenu,'Clear Route\nand Reset Program',clearRoutecheck,3,1)
    button_b(optionsMenu,'Manual Input\n(MIC)',t,1,2)
    button_s(optionsMenu,'Back to Main Menu',main_valid,3,3)
    button_s(optionsMenu,'System Options',systemOptions_screen,2,3)
    button_s(optionsMenu,'Lock System',LockScreen,2,4)
    button_d(optionsMenu,'Quit Program',quitprogram,3,4)

    optionsMenu.mainloop()


def clearRoutecheck():
    global clrRtChk             #global to allow close() to run
    close()                 #close all other windows
    clrRtChk = Tk()             #create window
    clrRtChk.state("zoomed")    #set window to fullscreen
    clrRtChk.resizable(False, False)                #disallows the user to resize the window
    clrRtChk.title('Train Announcement Systems - Confirm Option')        #set title of window
    label_one(clrRtChk)                 #sets main title in the 'main' window
    label_two(clrRtChk,'Are you sure you want to clear the entire route?')     #sets secondary title
    label_nxtstop(clrRtChk)

    button_dbig(clrRtChk,'YES',clearRoute,0.3,0.58)         #creates all buttons in the correct place 
    button_b(clrRtChk,'NO',options_screen,0.7,0.58)           #using the grid system in the button_b/s/d subroutines

    clrRtChk.mainloop()


def editStops_menu():
    global editStops,StopToEdit            #global to allow close() to run
    close()                 #close all other windows
    editStops = Tk()             #create window
    editStops.state("zoomed")    #set window to fullscreen
    editStops.resizable(False, False)                #disallows the user to resize the window
    editStops.title('Train Announcement Systems - Edit Stops')        #set title of window
    label_one(editStops)                 #sets main title in the 'main' window
    label_two(editStops,'Edit Stops')     #sets secondary title
    label_nxtstop(editStops)

    button_b(editStops,'Remove Stop',removeSelStop,1,2)
    button_b(editStops,'Replace Stop',replaceStop_screen,2,2)
    button_s(editStops,'Back to Options',options_screen,3,3)
    button_d(editStops,'Quit Program',quitprogram,3,4)

    data = read_db_col('RouteStops','StopName')           #gets all the stops that are programmed in the route

    options = []        #create blank list

    for i in range (len(data)):     #add stops from db to list
        options.append(str(data[i]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
    
    StopToEdit = StringVar(editStops)
    StopToEdit.set('Select Stop to edit')             #sets the text in the dropdown before option selected

    drop = OptionMenu(editStops,StopToEdit,*options)   #creates the dropdown menu  
    drop.config(width=20, font=('Arial',20))        #Defines the text formatting for the dropdown
    drop.place(relx=0.5,rely=0.45,anchor='center')  #places the dropdown


    editStops.mainloop()        #mainloop tkinter window


def replaceStop_screen():
    global replace,newStop,StopToEdit     #to ensure that the manualEntry window can be used anywhere in the program
    
    if StopToEdit.get() != 'Select Stop to edit':
    
        close()             #close all other open window
        replace = Tk()          #create window
        replace.state("zoomed")                        #sets the window to fullscreen
        replace.resizable(False, False)                #disallows the user to resize the window
        replace.title("Train Announcement Systems - Replace Stop")    #sets the title of the window
        label_one(replace)                             #displays the main title
        label_two(replace,"Replace Stop ({})".format(StopToEdit.get()))    #displays the secondary title, which is defined here

        button_b(replace,'Confirm replacement',confirmReplace,1,2)
        button_s(replace,'Initialisation Menu',init_screen,3,3)
        button_d(replace,'Quit Program',quitprogram,3,4)

        data = read_db_col('AllAvailFiles','StopName')           #to be replaced with options available from db

        options = []

        for i in range (len(data)):
            options.append(str(data[i]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))

        options = sorted(options)                                   #sorts the list into alphabetical order
        
        newStop = StringVar(replace)
        newStop.set('Choose a new stop')             #sets the text in the dropdown before option selected


        drop = OptionMenu(replace,newStop,*options)   #creates the dropdown menu  
        drop.config(width=20, font=('Arial',20))        #Defines the text formatting for the dropdown
        drop.place(relx=0.5,rely=0.45,anchor='center')  #places the dropdown

        replace.mainloop()          #loop whilst the window is open

    else:
        msg('Error','There is no stop selected to be replaced.')



def presetOptions():
    global presetOption_menu, presetToLoad     #to ensure that the manualEntry window can be used anywhere in the program
    
    close()             #close all other open window
    presetOption_menu = Tk()          #create window
    presetOption_menu.state("zoomed")                        #sets the window to fullscreen
    presetOption_menu.resizable(False, False)                #disallows the user to resize the window
    presetOption_menu.title("Train Announcement Systems - Preset Options")    #sets the title of the window
    label_one(presetOption_menu)                             #displays the main title
    label_two(presetOption_menu,"Preset Options")    #displays the secondary title, which is defined here

    button_b(presetOption_menu,'Import selected preset',importPreset,1,2)
    button_s(presetOption_menu,'Initialisation Menu',init_screen,3,3)
    button_d(presetOption_menu,'Quit Program',quitprogram,3,4)

    data = read_db_col('AvailPresets','Name')           #to be replaced with options available from db

    options = []

    for i in range (len(data)):
        options.append(str(data[i]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))

    options = sorted(options)                                   #sorts the list into alphabetical order
    
    presetToLoad = StringVar(presetOption_menu)
    presetToLoad.set('Select a Preset to import')             #sets the text in the dropdown before option selected


    drop = OptionMenu(presetOption_menu,presetToLoad,*options)   #creates the dropdown menu  
    drop.config(width=20, font=('Arial',20))        #Defines the text formatting for the dropdown
    drop.place(relx=0.5,rely=0.45,anchor='center')  #places the dropdown

    presetOption_menu.mainloop()          #loop whilst the window is open


def btpCountConfirm():
    global confirmBTP             #global to allow close() to run
    close()                 #close all other windows
    confirmBTP = Tk()             #create window
    confirmBTP.state("zoomed")    #set window to fullscreen
    confirmBTP.resizable(False, False)                #disallows the user to resize the window
    confirmBTP.title('Train Announcement Systems - Confirm BTP')        #set title of window
    label_one(confirmBTP)                 #sets main title in the 'main' window
    label_two(confirmBTP,'Please confirm your choice for the BTP announcement')     #sets secondary title
    label_nxtstop(confirmBTP)

    button_b(confirmBTP,'WITH BTP',playWelcomeYESBTP,0.3,0.58)         #creates all buttons in the correct place 
    button_b(confirmBTP,'WITHOUT BTP',playWelcomeNOBTP,0.7,0.58)           #using the grid system in the button_b/s/d subroutines


    confirmBTP.mainloop()    #loop whilst the window is open


def MicPassthroughScreen():
    global MicPassScr             #global to allow close() to run
    close()                 #close all other windows
    MicPassScr = Tk()             #create window
    MicPassScr.state("zoomed")    #set window to fullscreen
    MicPassScr.title('Train Announcement Systems - Microphone Passthrough Options')        #set title of window
    label_one(MicPassScr)                 #sets main title in the 'main' window
    label_two(MicPassScr,'Microphone Passthrough Options')     #sets secondary title


    label_nxtstop(MicPassScr)           #shows the next stop in the top left of the screen

    button_b(MicPassScr,'Start Passthrough',startPass,0.3,0.58)         #creates all buttons in the correct place 
    button_b(MicPassScr,'Stop Passthrough',stopPass,0.7,0.58)           #using the grid system in the button_b/s/d subroutines

    MicPassScr.mainloop()    #loop whilst the window is open


def LockScreen():
    global lock,prov_pin            #global to allow close() to run, and pin to be checked
    close()                 #close all other windows
    lock = Tk()             #create window
    lock.state("zoomed")    #set window to fullscreen
    lock.title('Train Announcement Systems - System Locked')        #set title of window
    label_one(lock)                 #sets main title in the 'main' window
    label_two(lock,'System Locked\n\nEnter Pin to proceed')         #sets secondary title of page
    label_nxtstop(lock)         #shows the next stop in the top left of the screen

    value = Label(lock, text='Pin Input\n\n{}'.format(prov_pin), font=("Arial",40, 'bold'))     #creates the label using the cast values
    value.place(relx = 0.2,rely = 0.6,anchor = 'center')

    button_pin(lock,'1',pinOneL,1,1)             #each of these use the subroutine 'button_pin' to
    button_pin(lock,'2',pinTwoL,2,1)                 #^ create a push button keypad to enter the pin
    button_pin(lock,'3',pinThreeL,3,1)
    button_pin(lock,'4',pinFourL,1,2)           #THIS USES THE 'L' AT THE END OF THE COMMAND,
    button_pin(lock,'5',pinFiveL,2,2)               #^^^^THIS USES A DIFFERENT BUTTON FUNCTION THAN THE PIN CHANGE SCREEN
    button_pin(lock,'6',pinSixL,3,2)
    button_pin(lock,'7',pinSevenL,1,3)
    button_pin(lock,'8',pinEightL,2,3)
    button_pin(lock,'9',pinNineL,3,3)
    button_pin(lock,'0',pinZeroL,2,4) 
    button_pin(lock,'Ent',pinEnterL,3,4) 
    button_pin(lock,'Clr',pinClearL,1,4)

    lock.mainloop()    #loop whilst the window is open


def systemOptions_screen():
    global systemOptions,chimeState,chimeAllowedFunc             #global to allow close() to run
    close()                 #close all other windows
    systemOptions = Tk()             #create window
    systemOptions.state("zoomed")    #set window to fullscreen
    systemOptions.resizable(False, False)                #disallows the user to resize the window
    systemOptions.title('Train Announcement Systems - System Options')        #set title of window
    label_one(systemOptions)                 #sets main title in the 'main' window
    label_two(systemOptions,'System Options')     #sets secondary title
    label_nxtstop(systemOptions)

    data = read_db_col('Config','Chime')                #get the current setting for the chime
    req_data = str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')

    if req_data == '1':             #if the chime is already on, set the chimeState to 'on' and the Chime allowed function to 'off'
        chimeState = 'On'               ##^^ these are then shown on the button label
        chimeAllowedFunc = 'Off'
    else:
        chimeState = 'Off'
        chimeAllowedFunc = 'On'


    button_b(systemOptions,'Chime is {}\n\nTurn Chime {}?'.format(chimeState,chimeAllowedFunc),changeChimeSetting,1,1)          
    button_b(systemOptions,'Edit Pin',editPin_screen,2,1)                            #creates all buttons in the correct place
                                                                        #using the grid system in the button_b/s/d subroutines

    systemOptions.mainloop()


def editPin_screen():
    global editPin,prov_pin,pinWindowToOpen             #global to allow close() to run
    close()                 #close all other windows
    editPin = Tk()             #create window
    editPin.state("zoomed")    #set window to fullscreen
    editPin.resizable(False, False)                #disallows the user to resize the window
    editPin.title('Train Announcement Systems - Set New Pin')        #set title of window
    label_one(editPin)                 #sets main title in the 'main' window
    label_two(editPin,'Set New Pin')     #sets secondary title
    label_nxtstop(editPin)

    value = Label(editPin, text='Pin Input\n\n{}'.format(prov_pin), font=("Arial",40, 'bold'))     #creates the label using the cast values
    value.place(relx = 0.2,rely = 0.6,anchor = 'center')

    button_pin(editPin,'1',pinOneC,1,1)             #each of these use the subroutine 'button_pin' to
    button_pin(editPin,'2',pinTwoC,2,1)                 #^ create a push button keypad to enter the pin
    button_pin(editPin,'3',pinThreeC,3,1)
    button_pin(editPin,'4',pinFourC,1,2)            #THIS USES THE 'C' AT THE END OF THE COMMAND,
    button_pin(editPin,'5',pinFiveC,2,2)                #^^^^THIS USES A DIFFERENT BUTTON FUNCTION THAN THE LOCK SCREEN
    button_pin(editPin,'6',pinSixC,3,2)
    button_pin(editPin,'7',pinSevenC,1,3)
    button_pin(editPin,'8',pinEightC,2,3)
    button_pin(editPin,'9',pinNineC,3,3)
    button_pin(editPin,'0',pinZeroC,2,4) 
    button_pin(editPin,'Ent',pinEnterC,3,4) 
    button_pin(editPin,'Clr',pinClearC,1,4)

    editPin.mainloop()










##Database Subroutines##

##def create_db():            #procedure to create the database for the first time
##                                #will be very rarely used / mainly for testing and show purposes
##    con = sqlite3.connect("Database.db")
##    cur = con.cursor()
##    cur.execute("CREATE TABLE AllAvailFiles(RouteID,RouteName,StopID,StopName,MP3FilePath)")
##    cur.execute("CREATE TABLE RouteStops(StopNum INTEGER PRIMARY,RouteName,StopID,StopName,MP3FilePath)")
##    cur.execute("CREATE TABLE Config(Chime,CheckDuplicates)")
##    cur.execute("CREATE TABLE CrashLog(Date,Time,Message)")
##
##    con.commit()            #finalise all changes to the db
##
##    con.close()             #close the db
    

def addto_AllAvailFiles(RouteID,RouteName,StopID,StopName,MP3FilePath):     #procedure to add data to the AllAvailFiles table

    RouteID = str(RouteID)
    RouteName = str(RouteName)
    StopID = str(StopID)
    StopName = str(StopName)
    MP3FilePath = str(MP3FilePath)
    
    con = sqlite3.connect("Database.db")        #connect to the db
    cur = con.cursor()                          #generate a cursor to access the db
    
    data = [(RouteID,RouteName,StopID,StopName,MP3FilePath)]                #set all data as a list
    cur.executemany("INSERT INTO AllAvailFiles VALUES(?,?,?,?,?)", data)    #import this list into the database
    con.commit()            #finalise the changes

    con.close()             #save and close the db


def addto_RouteStops(RouteName,StopID,StopName,MP3FilePath):    #procedure to add data to the RouteStops table

    RouteName = str(RouteName)
    StopID = str(StopID)
    StopName = str(StopName)
    MP3FilePath = str(MP3FilePath)

    con = sqlite3.connect("Database.db")                        #connect to the db     
    cur = con.cursor()                                          #generate a cursor to access the db
    
    data = (RouteName,StopID,StopName,MP3FilePath)               #set all data as a list
    cur.execute("INSERT INTO RouteStops (RouteName,StopID,StopName,MP3FilePath) VALUES(?,?,?,?)", data)       #import this list into the database
    con.commit()            #finalise the changes

    con.close()             #save and close the db


def addto_AutoSave(RouteID,RouteName,StopID,StopName,MP3FilePath):      #procedure to add data to the AutoSave table

    RouteID = str(RouteID)
    RouteName = str(RouteName)
    StopID = str(StopID)
    StopName = str(StopName)
    MP3FilePath = str(MP3FilePath)
    
    con = sqlite3.connect("Database.db")        #connect to the db     
    cur = con.cursor()                          ##generate a cursor to access the db

    currentDateAndTime = datetime.datetime.now()        #get the current date and time
    time = currentDateAndTime.strftime("%H:%M:%S")      #use the above line to get the time, in H,M,S
    date = datetime.date.today()                        #get the current date
    
    data = [(date,time,RouteID,RouteName,StopID,StopName,MP3FilePath)]          #set all data as a list
    cur.executemany("INSERT INTO AutoSave VALUES(?,?,?,?,?,?,?)", data)         #import this list into the database
    con.commit()            #finalise the changes

    con.close()             #save and close the db


def addto_ErrorLog(Message):                    #procedure to add data to the CrashLog table

    Message = str(Message)
    
    con = sqlite3.connect("Database.db")        #connect to the db     
    cur = con.cursor()                          #generate a cursor to access the db

    currentDateAndTime = datetime.datetime.now()        #get the current date and time
    time = currentDateAndTime.strftime("%H:%M:%S")      #use the above line to get the time, in H,M,S
    date = datetime.date.today()                        #get the current date
    
    data = [(date,time,Message,Crash)]                                    #set all data as a list
    cur.executemany("INSERT INTO ErrorLog VALUES(?,?,?,?)", data)     #import this list into the database
    con.commit()            #finalise the changes

    con.close()             #save and close the db

def addto_Config(Chime,CheckDuplicates,Pin):                    #procedure to add data to the ErrorLog table
    
    con = sqlite3.connect("Database.db")        #connect to the db     
    cur = con.cursor()                          #generate a cursor to access the db
    
    data = [(Chime,CheckDuplicates,Pin)]                            #set all data as a list
    cur.executemany("INSERT INTO Config VALUES(?,?,?)", data)     #import this list into the database
    con.commit()            #finalise the changes

    con.close()             #save and close the db
    

def add_stop_to_RouteStops():               #procedure to add the data from 'AllAvailFiles' to 'RouteStops'
    global clicked, ManEntCounter

    if 'Select' not in clicked.get():           #checks that clicked.get() is not the default 'Select Stop {}'
        clicked = ((clicked.get()).replace('(','').replace("'","").replace(',','').replace(')',''))       #removes all unnecessary characters from the string
        
        addto_RouteStops((read_db_for_addtoRouteStops(clicked,'RouteName')),        #Uses the subroutine 'read_db_for_addtoRouteStops' and sends this return to 'addto_RouteStops'
                         (read_db_for_addtoRouteStops(clicked,'StopID')),           #this happens for all the data required in 'RouteStops'
                         (read_db_for_addtoRouteStops(clicked,'StopName')),
                         (read_db_for_addtoRouteStops(clicked,'MP3FilePath')))

        ManEntCounter+=1        #add one to the stop counter to show 'Select stop {}'


    close()
    manualEntry_screen()
    

def read_db_all(table):                         #function to read all the data in a table from the db
    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute("SELECT * FROM {}".format(table))                #select the required data from the db
    data = cur.fetchall()       #set the selected data to var 'data'

    con.close()             #save and close the db

    return data         #return the data to the variable calling the subroutine

def read_db_row(table,row):                  #function to read a specific row from the db
    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute("SELECT * FROM {}".format(table))                #select the required data from the db
    data = cur.fetchall()               #set the selected data to var 'data'
    data = data[row]                    #selects the required row from the list of data

    con.close()             #save and close the db

    return data             #return the data to the variable calling the subroutine

def read_db_row_last(table,column):                 #function to read the last row from a table in the subroutine
    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute("SELECT {} FROM {} ORDER BY ROWID DESC LIMIT 1".format(column,table))    #select the required data from the db
    data = cur.fetchone()       #set the data fetched by 'cur' to the var 'data'

    con.close()             #save and close the db

    return data         #return the data to the variable calling the subroutine

def read_db_col(table,column):                          #function to read a specified column from the table of the db
    con = sqlite3.connect("Database.db")                #connect to the db
    cur = con.cursor()                                  #generate a cursor to access the db

    cur.execute("SELECT {} FROM {}".format(column,table))                #select the required data from the db
    data = cur.fetchall()           #set the data fetched by 'cur' to the var 'data'

    con.close()             #save and close the db
            
    return data             #return the data to the variable calling the subroutine

def read_db_for_addtoRouteStops(term,column):           #function to read the daya from 'AllAvailFiles', then return to be added to 'RouteStops'
    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute("SELECT * FROM AllAvailFiles WHERE StopName = ?",[term])                #select the required data from the db
    data = cur.fetchall()                       #set the data fetched by 'cur' to the var 'data'

    if column == 'RouteID':             #select the correct column in the table based on the data the user is searching for
        i = 0
    elif column == 'RouteName':
        i = 1
    elif column == 'StopID':
        i=2
    elif column == 'StopName':
        i=3
    elif column == 'MP3FilePath':
        i=4
    
    for row in data:            #uses the above if statements to select the correct row
        data = row[i]

    con.close()             #save and close the db

    return data         #return the data to the variable calling the subroutine

def read_db_row_from_term(table,term):                  #function to read a specific row from the db
    term = str(term)                                #to ensure no errors when searching for the string
    
    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute("SELECT * FROM {}".format(table))   #select the required data from the db
    
    data = cur.fetchall()                           #set the selected data to var 'data'

    for i in range (len(data)):
        string_i = data[i]
        string = '{}'.format(string_i)
        if term in string:
            return data[i]

    con.close()             #save and close the db



def del_db_row(table,column,term):
    con = sqlite3.connect("Database.db")    # connect to the db
    cur = con.cursor()                      # generate a cursor to access the db

    cur.execute("DELETE FROM {} WHERE {}=?".format(table,column), [term])

    con.commit()    # save the changes

    con.close()     # close the db


def del_db_table(table):
    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute('DELETE FROM {}'.format(table))     #delete all data from the table

    con.commit()        #save the changes

    con.close()         #close the db


def skipStop():
    data = read_db_col('RouteStops','StopName')     #imports all the stops from the db
    currentstop = (str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
                #^^ removes all unnecesary characters from the string. 
    if len(data) >1:            #if this is the last stop, don't remove from db
        del_db_row('RouteStops','StopName',currentstop)
        close()         #refresh the page to show the new next stop in the top left
        options_screen()
    else:
        msg('Error','There are not enough stops in the list to skip a stop. There must always be at least 1 stop.\n\nIf you wish to clear the route, please use the other button. ')



def clearRoute():   #completly resets the route
    close()     #closes the current window
    del_db_table('RouteStops')      #deletes data from the db
    init_screen()       #re-opens the init screen to add stops again.


def removeSelStop():           #delete the selected stop from the route
    global StopToEdit           #global var for the dropdown selection from previous screen

    if StopToEdit.get() != 'Select Stop to edit':

        data = read_db_all('RouteStops')        #for getting length of route stops table

        if len(data) >1:        #check length >1
            del_db_row('RouteStops','StopName',StopToEdit.get())        #del row where 'StopName' contains the selected stop in the drop down
            msg('Stop Removed',"'{}' has been removed from the route".format(StopToEdit.get()))
            options_screen()        #go back to main screen
        else:
            msg('Error','There are not enough stops in the route to delete a stop. There must always be at least one stop.')
                    #^^error when there are not enough stops in the route to delete one

    else:
        msg('Error','There is no stop selected to be replaced.') 



def confirmReplace():
    global StopToEdit, newStop      #global all required variables

    curData = read_db_row_from_term('RouteStops',StopToEdit.get())      #imports the current data for the row the user wants to replace

    cur_RouteName   = str(curData[1])       #sets all the data to be replaced to specific variables
    cur_StopID      = str(curData[2])
    cur_StopName    = str(curData[3])
    cur_MP3FilePath = str(curData[4])

    newData = read_db_row_from_term('AllAvailFiles',newStop.get())      #imports the new data that the user wants to replace the current data with

    new_RouteName   = str(newData[1])       #sets all the data to replace with to specific variables
    new_StopID      = str(newData[2])
    new_StopName    = str(newData[3])
    new_MP3FilePath = str(newData[4])


    con = sqlite3.connect("Database.db")            #connect to the db
    cur = con.cursor()                              #generate a cursor to access the db

    cur.execute("UPDATE {} SET {} = REPLACE({}, ?, ?)".format('RouteStops','RouteName', 'RouteName'), (cur_RouteName, new_RouteName))
    cur.execute("UPDATE {} SET {} = REPLACE({}, ?, ?)".format('RouteStops','StopID', 'StopID'), (cur_StopID, new_StopID))
    cur.execute("UPDATE {} SET {} = REPLACE({}, ?, ?)".format('RouteStops','StopName', 'StopName'), (cur_StopName, new_StopName))
    cur.execute("UPDATE {} SET {} = REPLACE({}, ?, ?)".format('RouteStops','MP3FilePath', 'MP3FilePath'), (cur_MP3FilePath, new_MP3FilePath))
                                #^^^^ updates the required data in the 'RouteStops' table. 

    con.commit()        #commits the change
    con.close()         #close db
    
    msg("Woohoo","The stop '{}' has now been replaced by '{}'".format(StopToEdit.get(),newStop.get()))      #give user confirmation message

    main_screen()   #show main screen


def importPreset():
    global presetToLoad         #take the selected value from the dropdown in the window which calls this subroutine

    del_db_table('RouteStops')      #delete the RouteStops table before the preset is added

    all = read_db_all(presetToLoad.get())                           #get all the data from the table used to get the length
    RouteName = read_db_col(presetToLoad.get(),'RouteName')         #select all the data in the defined column in the preset table
    StopID = read_db_col(presetToLoad.get(),'StopID')               #^^
    StopName = read_db_col(presetToLoad.get(),'StopName')           #^^
    MP3FilePath = read_db_col(presetToLoad.get(),'MP3FilePath')     #^^

    if len(all) >0:         #if there is at least 1 stop in the route, run the import
    
        for i in range (len(all)):          #itterate through the whole table to add all the stops in the preset

            i_RouteName = (str(RouteName[i])).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')
            i_StopID = (str(StopID[i])).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')
            i_StopName = (str(StopName[i])).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')
            i_MP3FilePath = (str(MP3FilePath[i])).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')
                #^^ the above lines take the current 'i' value of all the lists for the db columns, then converts them to a string

            addto_RouteStops(i_RouteName,i_StopID,i_StopName,i_MP3FilePath)     #add the current row of data to the RouteStops table

        presetRead = read_db_all(presetToLoad.get())            #read all the data from the preset table
        routeRead = read_db_all('RouteStops')                   #read all the data from the RouteStops table

        if presetRead == routeRead:         #if the data is the same in the preset as the RouteStops table, the subroutine has run correctly
            msg('Woohoo','The preset has been successfully imported')       #success message
            main_screen()       #start main screen
        else:       #this will occur if RouteStops and the preset table are different
            msg('Error','The route could not been imported.\nYou will now be sent to the Initialisation Screen.')   #error message
            init_screen()   #return to the init screen to try importing a preset again, or to choose another import method. 

    else:       #if not at least 1 stop in the route, then error
        msg('Error','The route could not been imported.\nThere must be at least 1 stop in the route.\nYou will now be sent to the Initialisation Screen.')  #error message
        init_screen()       #return to the init screen to try importing a preset again, or to choose another import method.



    




    



##Subroutines for playing .mp3 files##


def play(name):
    global media            #global to allow close() to run
    close()                 #close all other windows
    media = Tk()             #create window
    media.state("zoomed")    #set window to fullscreen
    media.resizable(False, False)                #disallows the user to resize the window
    media.title('Train Announcement Systems - Playing Media')        #set title of window
    label_one(media)                 #sets main title in the 'main' window
    label_two(media,'Playing Media')     #sets secondary title
    label_nxtstop(media)

    if name == 'BTP Waiting':                       #if waiting for BTP after welcome, do not say 'playing'
        label_wait(media,"Waiting for BTP")
    else:
        label_wait(media,"Playing '{}'".format(name))           #this will be used most of the time

    audio_dir = "audio_files"       #subfolder of main folder for all .mp3 files5

    from pygame import mixer        #import module to play the files
    mixer.init()    #initialises pygame mixer
    mixer.music.load("{}\\{}\\{}.mp3".format(os.getcwd(),audio_dir,name)) #loads the correct mp3 file
    mixer.music.play()  #plays the mp3 file

    from mutagen.mp3 import MP3     #import module to get file length
    audio = MP3("{}\\{}\\{}.mp3".format(os.getcwd(),audio_dir,name))     #sets 'audio' variable to file path of mp3 file
    length = (audio.info.length)    #gets length of mp3

    media.after(int(round(length*1000,0)),lambda:media.destroy())       #close the window after the file has finished playing

    media.mainloop()                #tkinter mainloop



def playWelcomeNOBTP():
    global btpcount

    btpcount += 1       #incriement count by +1 to count the times the BTP message has been rejected

    if btpcount >3:     #if count is more than 3

        msg('BTP Rejected','The BTP message has been rejected for {} times in a row. Please confirm selection to ignore BTP announcement.'.format(btpcount-1))  #display message
        btpcount = -1                #reset counter to not show message if the BTP is immediatly rejected. Then will allow 3 more rejections by setting this to -1. 
        btpCountConfirm()           #window to confirm option of BTP message

    else:

        chime()         #play chime if required

        close()             #close all windows, so no windows open when media is playing
        stoplist = []       #create blank list for all stops to be loaded to
    
        data = read_db_col('RouteStops','StopName')     #gets the StopNames from the db
        for i in range (len(data)):                     #iterates through the data 
            var = str(data[i])          #prepares a var for the next line
            stoplist.append(var.replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
                    #^^^ - removes all unnecesary characters from the stop name and adds it to the list. 

        play('welcome')         #plays the initial welcome file
        laststop = (str(stoplist[-1]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
        play(laststop)          #plays the last stop on the route to fit the sentence.
        play('calling_at')      #play 'we'll be calling at' 

        countdown = len(stoplist)   #sets the initial countdown for the stops left to play

        for i in range (len(stoplist)):                 #iterates through the stoplist
            if countdown == 1 and len(data) != 1:       #checks if the stop is the last stop on the list
                play('and')                             #play 'and' file
                play(stoplist[i])                       #plays the next stop in the list iteration
                countdown -= 1                          #takes one away from the countdown to stop playing at the correct point
            elif countdown == 1 and len(data) == 1:
                play(stoplist[i])
                countdown -= 1
                play('only_stop')
                countdown -= 1
            elif countdown == 1 and len(data) != 1:
                play(stoplist[i])
                countdown -= 1
                play('only_stop_left')
                countdown -= 1
            else:
                play(stoplist[i])
                countdown -= 1

        main_screen()           #re-displays the main screen to allow the user to action another item subroutine



def playWelcomeYESBTP():
    global btpcount

    chime()         #play chime if required
    
    close()     #close all windows, so no windows open when media is playing
    stoplist = []       #create blank list for all stops to be loaded to

    btpcount = 0
    
    data = read_db_col('RouteStops','StopName')     #gets the StopNames from the db
    for i in range (len(data)):                     #iterates through the data 
        var = str(data[i])          #prepares a var for the next line
        stoplist.append(var.replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
                #^^^ - removes all unnecesary characters from the stop name and adds it to the list. 

    play('welcome')         #plays the initial welcome file
    laststop = (str(stoplist[-1]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
    play(laststop)          #plays the last stop on the route to fit the sentence.
    play('calling_at')      #play 'we'll be calling at' 

    countdown = len(stoplist)   #sets the initial countdown for the stops left to play

    for i in range (len(stoplist)):                 #iterates through the stoplist
        if countdown == 1 and len(data) != 1:       #checks if the stop is the last stop on the list
            play('and')                             #play 'and' file
            play(stoplist[i])                       #plays the next stop in the list iteration
            countdown -= 1                          #takes one away from the countdown to stop playing at the correct point
        elif countdown == 1 and len(data) == 1:
            play(stoplist[i])
            countdown -= 1
            play('only_stop')
            countdown -= 1
        elif countdown == 1 and len(data) != 1:
            play(stoplist[i])
            countdown -= 1
            play('only_stop_left')
            countdown -= 1
        else:
            play(stoplist[i])
            countdown -= 1

    play('BTP Waiting')
    playBTP()       #plays the BTP annoucment and then opens the main screen again



def playNextStop():
    chime()         #play chime if required
    close()         #closes all open windows
    data = read_db_col('RouteStops','StopName')     #imports all the stops from the db
    play('next_station_is')                         #plays line to say the 'next stop is'
    nextstopname = (str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
    play(nextstopname)          #plays the next stop on the route to fit the sentence.

    if len(data) == 1:              #checks if the stop is the last, and tells passengers if required
        play('terminates')
    elif len(data) == 2:            #checks if the stop is the penultimate stop, and informs passengers. 
        play('penultimate')

    main_screen()           #re-displays the main screen



def playApproaching():
    chime()         #play chime if required
    close()
    data = read_db_col('RouteStops','StopName')     #imports all the stops from the db
    play('approaching')                         #plays line to say the 'next stop is'
    nextstopname = (str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
    play(nextstopname)          #plays the next stop on the route to fit the sentence.

    if len(data) == 1:              #checks if the stop is the last, and tells passengers if required
        play('terminates')
        play('belongings')
    elif len(data) == 2:            #checks if the stop is the penultimate stop, and informs passengers.
        play('penultimate')

    main_screen()               #call the main screen to start another announcement.



def playThisIs():
    chime()         #play chime if required
    close()
    data = read_db_col('RouteStops','StopName')     #imports all the stops from the db
    play('this_is')                         #plays line to say the 'next stop is'
    currentstop = (str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']',''))
    play(currentstop)          #plays the next stop on the route to fit the sentence.

    if len(data) == 1:              #checks if the stop is the last, and tells passengers if required
        play('belongings')
        play('terminates_now')
    elif len(data) == 2:            #checks if the stop is the penultimate stop, and informs passengers.
        play('penultimate')
        play('belongings')
    else:
        play('belongings')
    
    if len(data) >1:            #if this is the last stop, don't remove from db, to allow repeated announcements. 
        del_db_row('RouteStops','StopName',currentstop)

    main_screen()       #call the main screen to start another announcement.



def playBTP():
    chime()         #play chime if required
    close()             #close the current window
    play('btp')         #play message
    main_screen()       #return to the main screen


def chime():            #to play chime before message if required

    data = read_db_col('Config','Chime')        #get config file setting for chime
    setting = str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')
        #^^^ get the data and set this to 'setting' variable, and remove all unnecesary characters

    if setting == '1':      #if the setting is true '1', then close all windows, and play the chime file
        close()
        play('chime')


def mic_passthrough():      #subroutine to create a passthrough for the user to do a manual PA
    global passthrough,stream_in,stream_out,p              #global var used to turn passthrough on or off using boolean, defined when passthrough is called
    
    chunk_size = 1024
    sample_format = pyaudio.paInt16
    channels = 1
    fs = 44100

    p = pyaudio.PyAudio()           #define p as 'pyaudio.PyAudio()' for shorter lines of code and ease of reading

    stream_in = p.open(format=sample_format,channels=channels,rate=fs,frames_per_buffer=chunk_size,input=True)          #open microphone stream

    stream_out = p.open(format=sample_format,channels=channels,rate=fs,frames_per_buffer=chunk_size,output=True)        #open speaker stream

    while passthrough == True:
        input_data = stream_in.read(chunk_size)                     #read input from the microphone            
        stream_out.write(input_data)                                #output the input through the speakers
        print('pass active')
        time.sleep(0.01)
##        passthrough = checkPassValue()
        checkToStop()



def checkToStop():
    global passthrough,stream_in,stream_out,p

    if passthrough == False:
        stream_in.stop_stream()
        stream_in.close()
        stream_out.stop_stream()
        stream_out.close()
        p.terminate()
        print('pass stopped')


##def checkPassValue():
##    global passthrough
##    return passthrough


def startPass():
    global passthrough
    passthrough = True
    mic_passthrough()


def stopPass():
    global passthrough
    passthrough = False
    options_screen()















##Utility Subroutines##

def main_valid():       #check that there are stops in 'RouteStops' before the main screen loads
    data = read_db_col('RouteStops','StopName')         #read data from routestops
    if len(data) >0:        #check if there is at least 1 stop
        main_screen()       #load the main screen, after checking that the data is valid
    else:               #if there are no stops selected, then reject and point back to init page
        msg('Error','There are no stops selected in the "RouteStops" table. Please re-select your stops.')
        init_screen()       #load init screen to re-input stops



def label_nxtstop(window):
    data = read_db_col('RouteStops','StopName')     #gets the stops on the route
    toshow = str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')
            #^^ sets the var 'toshow' to the first stop on the list
    
    text = Label(window, text=('Next Stop: {}'.format(toshow)), font=("Arial",20, 'bold'))     #creates the label using the cast values

    text.place(relx = 0.02,      #places the title in the correct place on the screen
               rely = 0.05,     #using the 'rel' functions places it relative to the screen, 
               anchor = 'w')        #therefore it will be in the same place on whatever screen.



def recAutosave():
    #check if 'RouteStops' is populated, then point to main menu, or back to init if not populated
    data = read_db_col('RouteStops','StopName')

    if data:        #if there is data in 'RouteStops' table, proceed. 
        msg('Autosave','The previous autosave has been succesfully recovered')
        main_screen()   #send to main screen
    else:
        msg('Autosave','There is no data in the required database table. Please select another option to import data. ')
            #reject the users request



def quitprogram():
    close()         #closes all open windows
    msg("PROGRAM CLOSED", 'The program has now been closed. If this was an accident, you can restart the program and recover the autosave.')
    exit()          #python general command to exit the program

    

def manualEntry_screen_setup():             #the first time that the 'ManualEntry' screen is opened, the 'RouteStops' table should be reset
    global ManEntCounter                #global the counter so the var is valid in other subroutines

    del_db_table('RouteStops')          #use subroutine to delete all data in the 'RouteStops' table
    msg("Reset Complete", 'The list of current stops on the route has been reset.')     #show a popup to say 'RouteStops' has been reset
    
    ManEntCounter = 1           #set the counter to 0 so the secondary title on the man entry screen says 1


    manualEntry_screen()            #open the manualEntry screen



def close():            #checks if a window is open, if so, close the window to avoid multiple 'mainloops' being open at the same time
    
    try:                #try to check the state of the window, this will only work if the window is open, and then the window will be destroyed
        if init.state() == "zoomed":
            init.destroy()
    except:
        closetemp=1         #if this does not work, then generate a random variable as a placeholder, this is not used anywhere else in the program
    try:
        if manualEntry.state() == "zoomed":
            manualEntry.destroy()
    except:
        closetemp=1
    try:
        if med_waiting.state() == "zoomed":
            med_waiting.destroy()
    except:
        closetemp=1
    try:
        if main.state() == "zoomed":
            main.destroy()
    except:
        closetemp=1
    try:
        if WelcSetup.state() == "zoomed":
            WelcSetup.destroy()
    except:
        closetemp=1
    try:
        if optionsMenu.state() == "zoomed":
            optionsMenu.destroy()
    except:
        closetemp=1
    try:
        if clrRtChk.state() == "zoomed":
            clrRtChk.destroy()
    except:
        closetemp=1
    try:
        if editStops.state() == "zoomed":
            editStops.destroy()
    except:
        closetemp=1
    try:
        if replace.state() == "zoomed":
            replace.destroy()
    except:
        closetemp=1
    try:
        if presetOption_menu.state() == "zoomed":
            presetOption_menu.destroy()
    except:
        closetemp=1
    try:
        if confirmBTP.state() == "zoomed":
            confirmBTP.destroy()
    except:
        closetemp=1
    try:
        if MicPassScr.state() == "zoomed":
            MicPassScr.destroy()
    except:
        closetemp=1
    try:
        if lock.state() == "zoomed":
            lock.destroy()
    except:
        closetemp=1
    try:
        if systemOptions.state() == 'zoomed':
            systemOptions.destroy()
    except:
        closetemp=1
    try:
        if editPin.state() == 'zoomed':
            editPin.destroy()
    except:
        closetemp=1
    try:
        if media.state() == 'zoomed':
            media.destroy()
    except:
        closetemp=1




        



def label_one(window):        #Header 1 Label subroutine, used for main header on pages
    text = Label(window, text='Train Annoucement Systems', font=("Arial",50, 'bold'))     #creates the label using the cast values

    text.place(relx = 0.5,      #places the title in the correct place on the screen
               rely = 0.15,     #using the 'rel' functions places it relative to the screen, 
               anchor = 'center')        #therefore it will be in the same place on whatever screen.



def label_two(window,title):        #Header 2 Label subroutine, used for secondary header on pages
    text = Label(window, text=title, font=("Arial",25, 'bold'))     #creates the label using the cast values

    text.place(relx = 0.5,      #places the title in the correct place on the screen
               rely = 0.25,     #using the 'rel' functions places it relative to the screen, 
               anchor = 'center')        #therefore it will be in the same place on whatever screen.


    
def label_wait(window,title):        #Header 2 Label subroutine, used for secondary header on pages
    text = Label(window, text=title, font=("Arial",25, 'bold'))     #creates the label using the cast values

    text.place(relx = 0.5,      #places the title in the correct place on the screen
               rely = 0.6,     #using the 'rel' functions places it relative to the screen, 
               anchor = 'center')        #therefore it will be in the same place on whatever screen.


    
def button_b(window,txt,com,x,y):       #used to create bigger buttons in a defined window
    global myFont

    myFont = font.Font(size=17)      #used to set the size of the text
    
    if x == 1:          #these if statements are used to make calling a button easier.
        x=0.2               #all buttons will be in some sort of grid format, and these
    elif x == 2:                #are the 0.2,0.5,0.8. By replacing 1,2,3 with the exact
        x=0.5                       #values, calling the button is easier.
    elif x == 3:                        #this is done for x and y values
        x=0.8

    if y == 1:
        y=0.5
    elif y == 2:
        y=0.8
    
    B = Button(window, text=txt, command=com, height=6, width=25)   #button parameters
    B['font'] = myFont                                              #set the font to button
    B.place(relx=x,rely=y,anchor='center')                          #placing the button



def button_s(window,txt,com,x,y):       #used to create smaller buttons in a defined window

    myFont = font.Font(size=17)      #used to set the size of the text
    
    if x == 1:          #these if statements are used to make calling a button easier.
        x=0.2               #all buttons will be in some sort of grid format, and these
    elif x == 2:                #are the 0.2,0.5,0.8. By replacing 1,2,3 with the exact
        x=0.5                       #values, calling the button is easier. 
    elif x == 3:                        #this is done for x and y values
        x=0.8

    if y == 1:
        y=0.43
    elif y == 2:
        y=0.565
    elif y == 3:
        y=0.725
    elif y == 4:
        y=0.85
        
    B = Button(window, text=txt, command=com, height=2, width=25)   #button parameters
    B['font'] = myFont                                              #set the font to button
    B.place(relx=x,rely=y,anchor='center')                          #placing the button



def button_d(window,txt,com,x,y):       #used to create smaller buttons in a defined window

    myFont = font.Font(size=17)      #used to set the size of the text
    
    if x == 1:          #these if statements are used to make calling a button easier.
        x=0.2               #all buttons will be in some sort of grid format, and these
    elif x == 2:                #are the 0.2,0.5,0.8. By replacing 1,2,3 with the exact
        x=0.5                       #values, calling the button is easier. 
    elif x == 3:                        #this is done for x and y values
        x=0.8

    if y == 1:
        y=0.43
    elif y == 2:
        y=0.565
    elif y == 3:
        y=0.725
    elif y == 4:
        y=0.85
        
    B = Button(window, text=txt, command=com, height=2, width=25, fg='red')     #button parameters
    B['font'] = myFont                                                          #set the font to button
    B.place(relx=x,rely=y,anchor='center')                                      #placing the button



def button_dbig(window,txt,com,x,y):

    myFont = font.Font(size=17)      #used to set the size of the text
    
    if x == 1:          #these if statements are used to make calling a button easier.
        x=0.2               #all buttons will be in some sort of grid format, and these
    elif x == 2:                #are the 0.2,0.5,0.8. By replacing 1,2,3 with the exact
        x=0.5                       #values, calling the button is easier.
    elif x == 3:                        #this is done for x and y values
        x=0.8

    if y == 1:
        y=0.5
    elif y == 2:
        y=0.8
    
    B = Button(window, text=txt, command=com, height=6, width=25, fg='red')   #button parameters
    B['font'] = myFont                                              #set the font to button
    B.place(relx=x,rely=y,anchor='center')






def t():        #Msg when button not implimented yet
    msg=messagebox.showinfo("Woah, I'm not there yet", 'This button is not yet implimented into the program. Please wait for an update coming soon!')



def msg(title,text):
    msg=messagebox.showinfo(title, text)






##Pin Entry for Lock Screen##

def button_pin(window,txt,com,x,y):

    myFont = font.Font(size=17)      #used to set the size of the text
    
    if x == 1:          #these if statements are used to make calling a button easier.
        x=0.7               #all buttons will be in some sort of grid format, and these
    elif x == 2:                #are the 0.2,0.5,0.8. By replacing 1,2,3 with the exact
        x=0.8                       #values, calling the button is easier.
    elif x == 3:                        #this is done for x and y values
        x=0.9

    if y == 1:
        y=0.45
    elif y == 2:
        y=0.6
    elif y ==3:
        y=0.75
    elif y == 4:
        y=0.9

    B = Button(window, text=txt, command=com, height=3, width=7)   #button parameters
    B['font'] = myFont                                              #set the font to button
    B.place(relx=x,rely=y,anchor='center')
    

def checkPin():           #subroutine to check pin against config file
    global prov_pin                   #global required variable from the screen calling this subroutine
    
    data = read_db_col('Config','LockPin')      #read the config file
    req_pin = str(data[0]).replace('(','').replace("'","").replace(',','').replace(')','').replace('[','').replace(']','')  
            #^^^^ find the required data in the config file, then remove all unnecessary characters
    
    if str(prov_pin) == str(req_pin):        #if the pins match, send user to main screen
        main_screen()
    else:                               #else, error msg and do not advance (unlock) the program
        msg('Error','Incorrect Pin')
        pinClearL()


def pinOneL():                               #all these are subroutines to handle pin button presses ON THE LOCK SCREEN
    global prov_pin
    prov_pin = '{}1'.format(prov_pin)       #add a number to the end of the string
    LockScreen()                            #refresh the lock screen
def pinTwoL():
    global prov_pin
    prov_pin = '{}2'.format(prov_pin)
    LockScreen()
def pinThreeL():
    global prov_pin
    prov_pin = '{}3'.format(prov_pin)
    LockScreen()
def pinFourL():
    global prov_pin
    prov_pin = '{}4'.format(prov_pin)
    LockScreen()
def pinFiveL():
    global prov_pin
    prov_pin = '{}5'.format(prov_pin)
    LockScreen()
def pinSixL():
    global prov_pin
    prov_pin = '{}6'.format(prov_pin)
    LockScreen()
def pinSevenL():
    global prov_pin
    prov_pin = '{}7'.format(prov_pin)
    LockScreen()
def pinEightL():
    global prov_pin
    prov_pin = '{}8'.format(prov_pin)
    LockScreen()
def pinNineL():
    global prov_pin
    prov_pin = '{}9'.format(prov_pin)
    LockScreen()
def pinZeroL():
    global prov_pin
    prov_pin = '{}0'.format(prov_pin)
    LockScreen()
def pinEnterL():
    global prov_pin
    checkPin()
    LockScreen()
def pinClearL():
    global prov_pin
    prov_pin = ''
    LockScreen()



def pinOneC():                               #all these are subroutines to handle pin button presses ON THE PIN CHANGE SCREEN
    global prov_pin
    prov_pin = '{}1'.format(prov_pin)       #add a number to the end of the string
    editPin_screen()                            #refresh the screen
def pinTwoC():
    global prov_pin
    prov_pin = '{}2'.format(prov_pin)
    editPin_screen()
def pinThreeC():
    global prov_pin
    prov_pin = '{}3'.format(prov_pin)
    editPin_screen()
def pinFourC():
    global prov_pin
    prov_pin = '{}4'.format(prov_pin)
    editPin_screen()
def pinFiveC():
    global prov_pin
    prov_pin = '{}5'.format(prov_pin)
    editPin_screen()
def pinSixC():
    global prov_pin
    prov_pin = '{}6'.format(prov_pin)
    editPin_screen()
def pinSevenC():
    global prov_pin
    prov_pin = '{}7'.format(prov_pin)
    editPin_screen()
def pinEightC():
    global prov_pin
    prov_pin = '{}8'.format(prov_pin)
    editPin_screen()
def pinNineC():
    global prov_pin
    prov_pin = '{}9'.format(prov_pin)
    editPin_screen()
def pinZeroC():
    global prov_pin
    prov_pin = '{}0'.format(prov_pin)
    editPin_screen()
def pinEnterC():
    global prov_pin
    NEWpinEnter()
def pinClearC():
    global prov_pin
    prov_pin = ''
    editPin_screen()


def changeChimeSetting():
    global chimeState,chimeAllowedFunc              #global variables so they can be used in the related screen

    data = read_db_row('Config',0)      #get data which is already in Config
    
    Chime = data[0]                     #sets data to specific variables
    CheckDuplicates = data[1]
    Pin = data[2]

    del_db_table('Config')              #deletes the current config file 

    if chimeAllowedFunc == 'On':                    #replaces the data with the updated chime setting
        addto_Config('1',CheckDuplicates,Pin)       #if setting chime to 'on' then insert a '1' to the chime setting
    else:
        addto_Config('0',CheckDuplicates,Pin)       #if setting chime to 'off' then insert a '0' to the chime setting

    systemOptions_screen()      #show options menu again, with updated label in button automatically


def NEWpinEnter():
    global prov_pin

    if len(prov_pin) <4:            #check that the length of the pin is valid
        msg('Error','Pin must be longer than 4 digits')
        pinClearC()
    else:
        data = read_db_row('Config',0)      #get data which is already in Config
    
        Chime = data[0]                     #sets data to specific variables
        CheckDuplicates = data[1]
        Pin = data[2]

        del_db_table('Config')              #deletes the current config file 

        addto_Config(Chime,CheckDuplicates,prov_pin)        #add the new pin to the db table

        msg('Pin Changed','Pin has been changed from {} to {}'.format(Pin,prov_pin))    #success message
        main_screen()       #re-display main screen











##Main Program##
    
ctypes.windll.shcore.SetProcessDpiAwareness(1)          #uses ctypes to make the windows sharper for tkinter
btpcount = 0                                            #set counter for how many times not playing the BTP announcement with welcome to 0, used in 'btpCountConfirm()'
init_screen()                                           #run the init (first) window and start the program

